﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.WinControls.UI;
using System.Windows.Forms;
using Telerik.WinControls.UI.Docking;
using System.Drawing;

namespace GridSomething
{
    class LogDocument : DocumentWindow
    {
        RadGridView grid = new RadGridView();
        public LogDocument()
        {
            AddGridToForm();
        }

        public void Load()
        {
            LoadGridWithData();
        }

        private void LoadGridWithData()
        {
            GridViewTextBoxColumn textBoxColumn = new GridViewTextBoxColumn();
            textBoxColumn.UniqueName = "TextBoxColumn";
            textBoxColumn.HeaderText = "Product Description";
            textBoxColumn.FieldName = "Description";
            textBoxColumn.Width = 150;
            grid.MasterGridViewTemplate.Columns.Add(textBoxColumn);

            GridViewDecimalColumn decimalColumn = new GridViewDecimalColumn();
            decimalColumn.UniqueName = "DecimalColumn";
            decimalColumn.HeaderText = "Freight Charges";
            decimalColumn.FieldName = "Freight";
            decimalColumn.DecimalPlaces = 1;
            decimalColumn.Width = 150;
            grid.MasterGridViewTemplate.Columns.Add(decimalColumn);

            for (int i = 0; i < 15; i++)
            {
                grid.Rows.Add(new object[] { "Product N"+i, i+10 });
            }          
        }


        private void AddGridToForm()
        {
            RadTabStrip radTabStrip = new Telerik.WinControls.UI.RadTabStrip();
            TabItem tabGridItem = new Telerik.WinControls.UI.TabItem();
            TabItem tabDetailItem = new Telerik.WinControls.UI.TabItem();
            //  
            // radTabStrip1 
            //  
            radTabStrip.AutoScrollMargin = new System.Drawing.Size(0, 0);
            radTabStrip.AutoScrollMinSize = new System.Drawing.Size(0, 0);
            radTabStrip.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(191)))), ((int)(((byte)(219)))), ((int)(((byte)(254)))));
            radTabStrip.Dock = DockStyle.Fill;
            radTabStrip.Location = new System.Drawing.Point(0, 0);
            radTabStrip.Name = "radTabStrip";
            radTabStrip.ScrollOffsetStep = 5;
            radTabStrip.TabScrollButtonsPosition = Telerik.WinControls.UI.TabScrollButtonsPosition.RightBottom;
            radTabStrip.Text = "radTabStrip";
            //  
            // tabGridItem 
            //  
            tabGridItem.Alignment = System.Drawing.ContentAlignment.BottomLeft;
            //  
            // tabItem1.ContentPanel 
            //  
            tabGridItem.ContentPanel.BackColor = System.Drawing.Color.Transparent;
            tabGridItem.ContentPanel.CausesValidation = true;
            tabGridItem.IsSelected = true;
            tabGridItem.Margin = new System.Windows.Forms.Padding(4, 0, 0, 0);
            tabGridItem.Name = "tabGridItem";
            tabGridItem.StretchHorizontally = false;
            tabGridItem.Text = "Grid";
            //  
            // tabItem2 
            //  
            tabDetailItem.Alignment = System.Drawing.ContentAlignment.BottomLeft;
            //  
            // tabItem2.ContentPanel 
            //  
            tabDetailItem.ContentPanel.BackColor = System.Drawing.Color.Transparent;
            tabDetailItem.ContentPanel.CausesValidation = true;
            tabDetailItem.Margin = new System.Windows.Forms.Padding(4, 0, 0, 0);
            tabDetailItem.Name = "tabDetailItem";
            tabDetailItem.StretchHorizontally = false;
            tabDetailItem.Text = "Item Detail";

            // TODO 
            // Add controls to show current row details in a form 

            grid.Dock = DockStyle.Fill;
            grid.RowsChanged += new Telerik.WinControls.UI.GridViewCollectionChangedEventHandler(GridRowsChanged);
            //grid.DoubleClick += new System.EventHandler(GridDoubleClick);
            // 
            // Add TabItems to TabStrip 
            // 
            radTabStrip.Items.AddRange(new Telerik.WinControls.RadItem[] { tabGridItem, tabDetailItem });
            // 
            // Add grid to tab 1 
            // 
            tabGridItem.ContentPanel.Controls.Add(grid);
            // 
            // Add tab strip to form 
            // 
            this.Controls.Add(radTabStrip);
        }


        /// <summary> 
        /// Persist changes to current row to database. 
        /// </summary> 
        /// <param name="sender"></param> 
        /// <param name="e"></param> 
        private void GridRowsChanged(object sender, GridViewCollectionChangedEventArgs e)
        {
            //Save();
        }

        public void DeleteRow()
        {
            if ((grid.CurrentRow != null) && (grid.CurrentRow.VisualElement.RowInfo is GridViewDataRowInfo))
            {
                grid.Rows.Remove((GridViewDataRowInfo)grid.CurrentRow.VisualElement.RowInfo);
            }
            //Save();
        } 
    }
}
